/*
 * @(#)semantics.h	1.2  3/18/87
 */
#ifndef semantics_h
#define semantics_h
#ifndef nodes_h
#include "nodes.h"
#endif

extern void DoneParsing();
NodePtr Construct(/* tag, nChildren, children */);
/* Tag tag; int nChildren; NodePtr children; */

NodePtr Copy(/* fNode */);
/* NodePtr fNode; */

NodePtr Copy1Node(/* fNode */);
/* NodePtr fNode; */

NodePtr buildSelection(/* fD1, fD2 */);
/* NodePtr fD1, fD2; */

NodePtr buildExpression1(/* fD1, fD2 */);
/* NodePtr fD1, fD2; */

NodePtr buildExpression2(/* fD1 */);
/* NodePtr fD1; */

NodePtr buildSymbol();

NodePtr Flatten(/* fSeq */);
/* NodePtr fSeq; */

NodePtr Distribute(/* fTag, fSeq, nArgs, firstArg */);
/* Tag fTag; NodePtr fSeq, firstArg; int nArgs; */   

NodePtr RCONS(), RAPPEND(), singleArg(), makeOpName();
#endif
